<template>
  <div>
    <v-autocomplete
      v-model="selectedItem"
      :items="icons"
      color="primary"
      class="mt-0 pt-0"
      outlined
      solo
      flat
      dense
      item-text="name"
      item-value="absolutePath"
      clearable
      return-object
      persistent-hint
      :error="validator.vista.imagen.$error"
      :filter="filter"
      :hint="selectedItem ? selectedItem.relativePath : ''"
    >
      <template v-if="validator.vista.imagen.$error" v-slot:append-outer>
        <v-popover placement="bottom-end" offset="16">
          <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
          <template slot="popover">
            <div @click="validator.vista.imagen.$reset()" v-close-popover>
              <span v-if="!validator.vista.imagen.required"
                >¡No te olvides de éste campo!</span
              >
            </div>
          </template>
        </v-popover>
      </template>
      <template v-slot:item="data">
        <div style="display : flex">
          <v-list-item-icon class="mt-0">
            <v-card height="45" class=" pa-1" color="grey">
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="data.item.src"
                width="40"
                class="white--text align-end"
              />
            </v-card>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>{{ data.item.name }}</v-list-item-title>
            <v-list-item-subtitle>{{
              data.item.relativePath
            }}</v-list-item-subtitle>
          </v-list-item-content>
        </div>
      </template>
    </v-autocomplete>
    <template v-if="selectedItem">
      <v-card width="80" height="80" class=" pa-1" color="grey">
        <v-img
          :contain="true"
          :aspect-ratio="1"
          position="center"
          :src="selectedItem.src"
          width="75"
          class="white--text align-end"
        />
      </v-card>
    </template>
  </div>
</template>
<script>
export default {
  name: "Component-Vistas",
  props: ["value", "validator"],
  data() {
    return {
      icons: [],
      search: null,
      selectedItem: null,
    };
  },
  watch: {
    selectedItem(val) {
      let absolutePath = null;
      if (val) {
        absolutePath = val.absolutePath;
      }
      this.$emit("value", absolutePath);
      this.dataValue = absolutePath;
    },
  },
  computed: {
    dataValue: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    filter(item, queryText, itemText) {
      return (
        item.relativePath
          .toLocaleLowerCase()
          .indexOf(queryText.toLocaleLowerCase()) > -1 ||
        itemText.toLocaleLowerCase().indexOf(queryText.toLocaleLowerCase()) > -1
      );
    },
    listIconos() {
      const illustrations = require.context("@/assets/img", true, /^.*\.svg$/);
      let key = illustrations.keys();
      key.forEach((element) => {
        let icon = element.replace("./", "");
        let filePathSplit = icon.split("/");
        let name = filePathSplit[filePathSplit.length - 1].replace(".svg", "");
        name = name.toUpperCase();
        this.icons.push({
          relativePath: icon,
          absolutePath: "@/assets/img/" + icon,
          src: require("@/assets/img/" + icon),
          name,
        });
      });
    },
  },
  created() {
    this.listIconos();
    let selectedItemTemp = this.icons.filter(
      (item) => item.absolutePath === this.value
    );
    if (selectedItemTemp) {
      this.selectedItem = selectedItemTemp[0];
    }
  },
};
</script>
